/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
#include "stdlib.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

int LAST;
int *new_inversed(int len, int *v)
{
  int i;
  int *p;
  __e_acsl_store_block((void *)(& p),(size_t)8);
  {
    int __gen_e_acsl_valid;
    int __gen_e_acsl_and;
    __e_acsl_store_block((void *)(& v),(size_t)8);
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"v",(void *)v);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,sizeof(int));
    __gen_e_acsl_valid = __e_acsl_valid((void *)v,sizeof(int),(void *)v,
                                        (void *)(& v));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"\\valid(v)",0,
                                 __gen_e_acsl_valid);
    if (__gen_e_acsl_valid) {
      unsigned long __gen_e_acsl_offset;
      __e_acsl_mpz_t __gen_e_acsl_offset_2;
      __e_acsl_mpz_t __gen_e_acsl_;
      __e_acsl_mpz_t __gen_e_acsl_add;
      unsigned long __gen_e_acsl_block_length;
      __e_acsl_mpz_t __gen_e_acsl_block_length_2;
      int __gen_e_acsl_le;
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"v",(void *)v);
      __gen_e_acsl_offset = __e_acsl_offset((void *)v);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "\\offset(v)",0,__gen_e_acsl_offset);
      __gmpz_init_set_ui(__gen_e_acsl_offset_2,__gen_e_acsl_offset);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"len",0,len);
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,4);
      __gmpz_init_set_si(__gen_e_acsl_,len * 4L);
      __gmpz_init(__gen_e_acsl_add);
      __gmpz_add(__gen_e_acsl_add,
                 (__e_acsl_mpz_struct const *)(__gen_e_acsl_offset_2),
                 (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
      __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"v",(void *)v);
      __gen_e_acsl_block_length = __e_acsl_block_length((void *)v);
      __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,
                                     "\\block_length(v)",0,
                                     __gen_e_acsl_block_length);
      __gmpz_init_set_ui(__gen_e_acsl_block_length_2,
                         __gen_e_acsl_block_length);
      __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_add),
                                   (__e_acsl_mpz_struct const *)(__gen_e_acsl_block_length_2));
      __gen_e_acsl_and = __gen_e_acsl_le <= 0;
      __gmpz_clear(__gen_e_acsl_offset_2);
      __gmpz_clear(__gen_e_acsl_);
      __gmpz_clear(__gen_e_acsl_add);
      __gmpz_clear(__gen_e_acsl_block_length_2);
    }
    else __gen_e_acsl_and = 0;
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(v) && \\offset(v) + len * sizeof(int) <= \\block_length(v)";
    __gen_e_acsl_assert_data.file = "tests/memory/vector.c";
    __gen_e_acsl_assert_data.fct = "new_inversed";
    __gen_e_acsl_assert_data.line = 12;
    __e_acsl_assert(__gen_e_acsl_and,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid(v) && \offset(v) + len * sizeof(int) <= \block_length(v);
   */
  ;
  __e_acsl_full_init((void *)(& p));
  p = (int *)malloc(sizeof(int) * (unsigned long)len);
  i = 0;
  while (i < len) {
    __e_acsl_initialize((void *)(p + i),sizeof(int));
    *(p + i) = *(v + ((len - i) - 1));
    i ++;
  }
  __e_acsl_delete_block((void *)(& v));
  __e_acsl_delete_block((void *)(& p));
  return p;
}

int main(void)
{
  int __retres;
  int *v2;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  __e_acsl_store_block((void *)(& v2),(size_t)8);
  int x = 3;
  int v1[3] = {1, 2, x};
  __e_acsl_store_block((void *)(v1),(size_t)12);
  __e_acsl_full_init((void *)(& v1));
  {
    int __gen_e_acsl_valid;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data,"&v1[2]",
                                 (void *)(& v1[2]));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data,"sizeof(int)",
                                   0,sizeof(int));
    __gen_e_acsl_valid = __e_acsl_valid((void *)(& v1[2]),sizeof(int),
                                        (void *)(v1),(void *)0);
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\valid(&v1[2])",0,__gen_e_acsl_valid);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\valid(&v1[2])";
    __gen_e_acsl_assert_data.file = "tests/memory/vector.c";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 22;
    __e_acsl_assert(__gen_e_acsl_valid,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \valid(&v1[2]); */ ;
  LAST = v1[2];
  {
    int __gen_e_acsl_initialized;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_2,"&v1[2]",
                                 (void *)(& v1[2]));
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_2,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_initialized = __e_acsl_initialized((void *)(& v1[2]),
                                                    sizeof(int));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\initialized(&v1[2])",0,
                                 __gen_e_acsl_initialized);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\initialized(&v1[2])";
    __gen_e_acsl_assert_data_2.file = "tests/memory/vector.c";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 24;
    __e_acsl_assert(__gen_e_acsl_initialized,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \initialized(&v1[2]); */ ;
  __e_acsl_full_init((void *)(& v2));
  v2 = new_inversed(3,v1);
  LAST = *(v2 + 2);
  {
    int __gen_e_acsl_initialized_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __e_acsl_assert_register_ptr(& __gen_e_acsl_assert_data_3,"v2",
                                 (void *)v2);
    __e_acsl_assert_register_ulong(& __gen_e_acsl_assert_data_3,
                                   "sizeof(int)",0,sizeof(int));
    __gen_e_acsl_initialized_2 = __e_acsl_initialized((void *)(v2 + 2),
                                                      sizeof(int));
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                 "\\initialized(v2 + 2)",0,
                                 __gen_e_acsl_initialized_2);
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\initialized(v2 + 2)";
    __gen_e_acsl_assert_data_3.file = "tests/memory/vector.c";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 27;
    __e_acsl_assert(__gen_e_acsl_initialized_2,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \initialized(v2 + 2); */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,"LAST",0,LAST);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "LAST == 1";
    __gen_e_acsl_assert_data_4.file = "tests/memory/vector.c";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 28;
    __e_acsl_assert(LAST == 1,& __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@ assert LAST == 1; */ ;
  free((void *)v2);
  __retres = 0;
  __e_acsl_delete_block((void *)(& v2));
  __e_acsl_delete_block((void *)(v1));
  __e_acsl_memory_clean();
  return __retres;
}


